{
JonComboBox is a desendant of TComboBox with one more
Event, OnSelect.
OnSelect is keyed off of OnChange.
If there are ITEMS, then when the TEXT == Item[i] then
OnSelect will fire (if assigned that is)
}

unit JonComboBox;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TNotifyEvent = procedure(Sender: TObject) of object;
  TJonComboBox = class(TComboBox)
  private
    { Private declarations }
       FOnChange: TNotifyEvent;
       FOnSelect: TNotifyEvent;
       FErrorString: String;
       FUnction CheckIt: Boolean;

  protected
    { Protected declarations }
  public
    { Public declarations }
    destructor Destroy; override;
    Procedure Change; override;
    Procedure Select;
    property ErrorString: String read FErrorString write FErrorString;

  published
    { Published declarations }
    property OnSelect: TNotifyEvent read FOnSelect write FOnSelect;
    property OnChange: TNotifyEvent read FOnChange write FOnChange;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Useless', [TJonComboBox]);
end;

destructor TJonComboBox.destroy;
begin
// put code here...

// last but not least:
  inherited Destroy;
end;

FUnction TJonComboBox.CheckIt: Boolean;
var i: integer;
begin
    CheckIt := False;
    if Items.Count > 0 then
    begin
         i := 0;
          while (i <= Items.Count -1) do
           begin
             if Items[i] = Text then
             begin
                CheckIt := True;
                FErrorString := ' i=   '+IntToStr(i)+'  Text is = to ' + Text;
                break;
             end;
             inc(i);
           end;
    end
    else CheckIt := False;
end;

procedure TJonComboBox.Change;
begin
  inherited Changed;
  if Assigned(FOnChange) then FOnChange(Self);
  if CheckIt then Select;
end;

procedure TJonComboBox.Select;
begin
   
   if Assigned(FOnSelect) then FOnSelect(Self);

end;

end.



